#include <iostream>

using namespace std;

int main()
{
    int n;
    cin>>n;
    int a[n-1], b[n-1], c[n-1], duz=1, l=1;
    bool promena=false;
    for (int i=1; i<n; i++)
        c[i]=0;
    for (int i=1; i<n; i++)
    {
        cin>>a[i]>>b[i];
    }
    for (int i=1; i<n; i++)
        c[a[i]]++;
    for (int i=1; i<n; i++)
    {
        for (int j=i+c[i]; j<n; j++)
        {
            if (b[j-1]==a[j])
                duz++;
            else
            {
                if (duz>l)
                {
                    promena=true;
                    l=duz;
                    duz=0;
                }
            }
        }
        if (promena!=true)
        {
            if (duz>l)
                l=duz;
            duz=0;
            promena=false;
        }
    }
    cout<<l/2;
}